/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package idats_2009_semestralka_a_MatejTrakal;

/**
 * Abstraktní datová struktura
 * cyklicky zřetězený seznam bez hlavy
 * @author Administrator
 * @param <objType> vstupní datový typ (struktura, která bude ukládána)
 */
public interface IAbstrDoubleList<objType> {

    /**
     * zrušení celého seznamu
     */
    void Zrus();

    /**
     * Zjistí zda-li je ADL prázdný
     * @return true = je prázdný, false = není prázdný
     */
    boolean jePrazdny();

    /**
     * odebrání (vyjmutí) aktuálního prvku ze seznamu aktuální prvek je nastaven
     * na první prvek
     * @return datová struktura vnitřního prvku
     */
    objType odeberAktualni();

    /**
     * Odebrání následníka aktuálního prvku ze seznamu
     * @return datová struktura vnitřního prvku
     */
    objType odeberNaslednika();

    /**
     * odebrání posledního prvku ze seznamu
     * @return datová struktura vnitřního prvku
     */
    objType odeberPosledni();

    /**
     * Odebrání předchůdce aktuálního prvku ze seznamu
     * @return datová struktura vnitřního prvku
     */
    objType odeberPredchudce();

    /**
     * odebrání prvního prvku ze seznamu
     * @return datová struktura vnitřního prvku
     */
    objType odeberPrvni();

    /**
     * vložení prvku do seznamu jakožto následníka aktuálního prvku
     * @param obj datová struktura vkládaných prvků
     */
    void vlozNaslednika(objType obj);

    /**
     * vložení prvku do seznamu na poslední místo
     * @param obj datová struktura vkládaných prvků
     */
    void vlozPosledni(objType obj);

    /**
     * vložení prvku do seznamu jakožto předchůdce aktuálního prvku
     * @param obj datová struktura vkládaných prvků
     */
    void vlozPredchudce(objType obj);

    /**
     * vložení prvku do seznamu na první místo
     * @param obj datová struktura vkládaných prvků
     */
    void vlozPrvni(objType obj);

    /**
     * Vytvoří iterátor pro ADL
     * @return ukazatel na vytvořený Iterátor
     */
    IIterator<objType> vytvorIterator();

    /**
     * zpřístupnění aktuálního prvku seznamu
     * @return datová struktura vnitřního prvku
     */
    objType zpristupniAktualni();

    /**
     * zpřístupnění následníka aktuálního prvku
     * @return datová struktura vnitřního prvku
     */
    objType zpristupniNaslednika();

    /**
     * zpřístupnění posledního prvku seznamu
     * @return datová struktura vnitřního prvku
     */
    objType zpristupniPosledni();

    /**
     * zpřístupnění předchůdce aktuálního prvku
     * @return datová struktura vnitřního prvku
     */
    objType zpristupniPredchudce();

    /**
     * zpřístupnění prvního prvku seznamu
     * @return datová struktura vnitřního prvku
     */
    objType zpristupniPrvni();
}
