/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package idats_2009_semestralka_a_MatejTrakal_B;

/**
 *
 * @author Administrator
 */
public interface ISeznamOsob {

    /**
     * Načtení dat ze souboru
     *
     * Využita metoda z předmětu IJAV (loňský rok)
     *
     * @param nazevSouboru celý název souboru ze kterého se budou načítat data
     */
    void nactiZeSouboru(String nazevSouboru);

    /**
     * Načtení dat ze souboru s názvem data.dta
     */
    void nactiZeSouboru();

    /**
     * vyhledání osoby ve struktuře a uplatnění heuristiky move-to-front
     * @param key Klíč podle kterého se bude hledat v ADL shodný výskyt
     * @return IOsoba, pokud nenalzene osobu, vrací null
     */
    IOsoba najdi(IOsoba key);

    /**
     * odebrání definovaného osoby  ze struktury
     * @param osoba
     * @return IOsoba, pokud nenalzene osobu, vrací null
     */
    IOsoba odeber(IOsoba osoba);

    /**
     * Uložení dat do souboru
     *
     * Využita metoda z předmětu IJAV (loňský rok)
     *
     * @param nazevSouboru název souboru, do kterého se bude ukládat
     */
    void ulozDoSouboru(String nazevSouboru);

    /**
     * Uložení dat do souboru s názvem data.dta
     */
    void ulozDoSouboru();

    /**
     * Uložení dat do textového souboru
     *
     * @param nazevSouboru název souboru, do kterého se bude ukládat
     */
    void ulozDoTxtSouboru(String nazevSouboru);

    /**
     * vložení dané osoby do struktury (pokud ji tato již neobsahuje)
     * na poslední místo seznamu
     * @param osoba Datová struktura, která bude vkládána do ADL
     */
    void vloz(IOsoba osoba);

    /**
     * Výpis všech prvků uložených v ADL pomocí iterátoru (na standardní výstup)
     */
    void vypis();

    /**
     * Zrušení celého seznamu
     */
    void zrus();

}
