/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package idats_2009_semestralka_a_MatejTrakal_B;

import idats_2009_semestralka_a_MatejTrakal.*;
import java.io.IOException;
import java.io.Serializable;
import javax.annotation.processing.FilerException;

/**
 * Seznam všech osob, které budou ukládány do ADL
 * @author Administrator
 */
public class SeznamOsob implements Serializable, ISeznamOsob {

    private IAbstrDoubleList<IOsoba> abstrDoubleList = new AbstrDoubleList<IOsoba>() {
    };

    /**
     * vložení dané osoby do struktury (pokud ji tato již neobsahuje)
     * na poslední místo seznamu
     * @param osoba Datová struktura, která bude vkládána do ADL
     */
    public void vloz(IOsoba osoba) {
        //if (!(najdi(osoba) instanceof IOsoba)) {
        if (najdi(osoba) == null) {
            abstrDoubleList.vlozPosledni(osoba);
        }
        //}
    }

    /**
     * vyhledání osoby ve struktuře a uplatnění heuristiky move-to-front
     * @param key Klíč podle kterého se bude hledat v ADL shodný výskyt
     * @return IOsoba, pokud nenalzene osobu, vrací null
     */
    public IOsoba najdi(IOsoba key) {
        IIterator<IOsoba> iIterator = abstrDoubleList.vytvorIterator();
        IOsoba iOsoba;
        while (iIterator.hasNext()) {
            if ((iOsoba = iIterator.next()).equals(key)) {
                //iOsoba = (IOsoba) iIterator.next();
                //if(key.getJmeno() == iOsoba.getJmeno() && key.getPrijmeni() == iOsoba.getPrijmeni() && key.getId() == iOsoba.getId()) {
                moveToFront(iOsoba);
                return iOsoba;
            }
        }
        iIterator = null;
        return null;
    }

    /**
     * odebrání definovaného osoby  ze struktury
     * @param osoba
     * @return IOsoba, pokud nenalzene osobu, vrací null
     */
    public IOsoba odeber(IOsoba osoba) {
        //if (najdi(osoba) instanceof IOsoba) {
        if(najdi(osoba) != null) {
        return abstrDoubleList.odeberPrvni();
        }
        //}
        return null;
    }

    /**
     * Přesunutí akutálního prvku na začátek seznamu
     * @param key klíč podle kterého se vyhledá pozice prvku pro přesun
     */
    private void moveToFront(IOsoba key) {
        abstrDoubleList.vlozPrvni(key);
        abstrDoubleList.odeberAktualni();
    }

    /**
     * Výpis všech prvků uložených v ADL pomocí iterátoru (na standardní výstup)
     */
    public void vypis() {
        IIterator<IOsoba> iIterator = abstrDoubleList.vytvorIterator();
        while (iIterator.hasNext()) {
            System.out.println(iIterator.next());
        }
    }

    /**
     * Zrušení celého seznamu
     */
    public void zrus() {
        abstrDoubleList.Zrus();
    }

    /**
     * Načtení dat ze souboru
     *
     * Využita metoda z předmětu IJAV (loňský rok)
     *
     * @param nazevSouboru celý název souboru ze kterého se budou načítat data
     */
    public void nactiZeSouboru(String nazevSouboru) {
        ISoubor iSoubor = new Soubor();

        try {
            this.abstrDoubleList = (IAbstrDoubleList<IOsoba>) iSoubor.nacti(nazevSouboru);
        } catch (FilerException e) {
            e.printStackTrace();
        } catch (ClassNotFoundException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    /**
     * Načtení dat ze souboru s názvem data.dta
     */
    public void nactiZeSouboru() {
        nactiZeSouboru("data.dta");
    }

    /**
     * Uložení dat do souboru
     *
     * Využita metoda z předmětu IJAV (loňský rok)
     *
     * @param nazevSouboru název souboru, do kterého se bude ukládat
     */
    public void ulozDoSouboru(String nazevSouboru) {
        ISoubor iSoubor = new Soubor();

        try {
            iSoubor.uloz(nazevSouboru, this.abstrDoubleList);
        } catch (FilerException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    /**
     * Uložení dat do souboru s názvem data.dta
     */
    public void ulozDoSouboru() {
        ulozDoSouboru("data.dta");
    }

    /**
     * Uložení dat do textového souboru
     *
     * @param nazevSouboru název souboru, do kterého se bude ukládat
     */
    public void ulozDoTxtSouboru(String nazevSouboru) {
        ISouborTxt iSouborTxt = new SouborTxt();
        try {
            iSouborTxt.uloz(nazevSouboru, false ,this.abstrDoubleList);
        } catch (FilerException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}
